import sys, os
import Photo
from Products.CMFCore import utils, DirectoryView
from zLOG import LOG, PROBLEM, DEBUG, ERROR

ADD_CONTENT_PERMISSION = 'Add portal content' # disgusting isn't it ?

bases = (Photo.Photo, )

this_module = sys.modules[__name__]
z_bases = utils.initializeBasesPhase1(bases, this_module)

photo_globals = globals()

DirectoryView.registerDirectory('skins', globals())

try:
    import PIL.Image
except ImportError, err:
    LOG('CMFPhoto', PROBLEM, 'PIL not found', 'The Python Imaging Library \
(http://www.pythonware.com/products/pil/) was not found. Trying to use \
ImageMagick.')
    
    has_convert = None
    if sys.platform == 'win32':
        convert = 'convert.exe'
    else:
        convert = 'convert'

    syspath = [p for p in os.environ['PATH'].split(os.pathsep) ]
    for path in syspath:
        if os.path.isdir(path):
            if convert in [ entry.lower() for entry in os.listdir(path) ]:
                LOG('CMFPhoto', DEBUG, 'ImageMagick found', 'The ImageMagick convert tool was found in %s in your search path.' % path)
                has_convert = 1
                break
    
    if not has_convert:
        LOG('CMFPhoto', ERROR, 'No image converting tool was found', 
        'CMFPhoto wasn\'t able to find PIL or ImageMagick! CMFPhoto needs \
one of this programs to work. Aborting ...')
        # do not raise the error - backward compatibility
        # raise ImportError, 'PIL and ImageMagick are not available.'


def initialize(registrar):
    utils.initializeBasesPhase2(z_bases, registrar)
    utils.ContentInit(
        'CMFPhoto',
        content_types = bases,
        permission = ADD_CONTENT_PERMISSION,
        extra_constructors = (Photo.addPhoto, ),
        fti = (Photo.factory_type_information, ),
        ).initialize(registrar)

